/*
 * (C) Copyright 2006-2011 Nuxeo SA (http://nuxeo.com/) and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Lesser General Public License
 * (LGPL) version 2.1 which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/lgpl-2.1.html
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * Contributors:
 *     Thomas Roger <troger@nuxeo.com>
 */

package org.nuxeo.ecm.platform.content.template.tests;

import org.nuxeo.ecm.core.api.DocumentModel;
import org.nuxeo.ecm.core.api.DocumentModelList;
import org.nuxeo.ecm.core.storage.sql.SQLRepositoryTestCase;
import org.nuxeo.ecm.platform.content.template.service.ContentTemplateService;
import org.nuxeo.runtime.api.Framework;

/**
 * @author <a href="mailto:troger@nuxeo.com">Thomas Roger</a>
 * @since 5.5
 */
public class PostContentCreationHandlersTest extends SQLRepositoryTestCase {

    protected ContentTemplateService service;

    @Override
    public void setUp() throws Exception {
        super.setUp();
        deployBundle("org.nuxeo.ecm.platform.content.template");
        deployContrib("org.nuxeo.ecm.platform.content.template.tests",
                "test-content-template-handlers-contrib.xml");
        openSession();

        service = Framework.getLocalService(ContentTemplateService.class);
    }

    @Override
    public void tearDown() throws Exception {
        closeSession();
        super.tearDown();
    }

    public void testHandler() throws Exception {
        deployContrib("org.nuxeo.ecm.platform.content.template.tests",
                "test-content-template-handlers-contrib.xml");
        DocumentModel root = session.getRootDocument();
        DocumentModelList rootChildren = session.getChildren(root.getRef());
        assertEquals(2, rootChildren.size());

        DocumentModel child = rootChildren.get(1);
        assertNotNull(child);
        assertEquals(SimplePostContentCreationHandler.DOC_NAME, child.getName());
        assertEquals(SimplePostContentCreationHandler.DOC_TYPE, child.getType());
    }

}
